# Apache SITE Views Classes should be coded here.
import lib.datamodel.datatypes
from lib.common.convertunits import convert_to_MB

class GroupListEntryView (lib.datamodel.datatypes.EntryView):
    def view_actions (self, entry):
        if 'actions' in entry:
            if 'delete' in entry['actions']:
                return '''<a href = "/siteadmin/services/apache/removeGroup?group=%s"><img name="delete:group" title=%s alt=%s border=0 src="/static/images/delete.gif"></a>'''%(entry['group'], _('Delete'), _('Delete'))

    def view_users ( self, entry ):
        if len(entry['users']) > 0:
            return ','.join( entry['users'] )
        else:
            return '&nbsp;'

class UserListEntryView (lib.datamodel.datatypes.EntryView):
    def view_actions (self, entry):
        return '''<a href = "/siteadmin/services/apache/editUser?user=%s"><img title=%s alt=%s border=0 src="/static/images/configure.gif"></a><a href = "/siteadmin/services/apache/removeUser?user=%s"><img name="delete:user" title=%s alt=%s border=0 src="/static/images/delete.gif"></a>'''%(entry['name'],_('Edit'), _('Edit'),entry['name'],_('Delete'),_('Delete'))


class DirectoryListEntryView( lib.datamodel.datatypes.EntryView ):
    def view_secure( self, entry ):
        tmp_dict ={}
        tmp_dict['path'] = entry['path']
        if entry.has_key('secure') and entry['secure']:
            tmp_dict['msg'] = _('Unprotect Directory')
            return "<a href='/siteadmin/services/apache/unprotectDirectory?path=%(path)s'><img src='/static/images/unprotect.gif' title='%(msg)s'></a>"%(tmp_dict)
        elif entry.has_key('secure') and (not entry['secure']):
            tmp_dict['msg'] = _('Protect Directory')
            return "<a href='/siteadmin/services/apache/protectDirectoryForm?path=%(path)s'><img src='/static/images/protect.gif' title='%(msg)s''></a>" %(tmp_dict)

    def view_path( self, entry ):
        if entry.has_key('secure') and entry['secure']:
            return entry['path'] + " %s" %(_("is protected"))
        else:
            return entry['path'] + " %s" %(_("is unprotected"))
        return entry['path']

    def view_passwdfile( self, entry ):
        if entry.has_key('secure') and entry['secure']:
            return "<a href='/siteadmin/services/apache/repairDirectory?dirname=%s'>%s</a>"%(entry['path'],_('Repair'))
        elif entry.has_key('secure') and (not entry['secure']):
            return ''

class LogFilesListEntryView( lib.datamodel.datatypes.EntryView ):
    def view_log( self, entry ):
        return entry['location']

    def view_actions( self, entry ):
        return "<a href='/siteadmin/services/apache/downloadLogFile?logfile=%s'>%s</a>"%(entry['log'], _('Download'))

    def view_size( self, entry ):
        return convert_to_MB(entry['size'],'M')
